<template>
  <div class="sort pagePadding">
    <ex-table
      v-loading="loading"
      :table="table"
      :data="tableData"
      :columns="columns"
      :page="pageInfo"
      :size="size"
      @page-curr-change="handlePageChange"
      @page-size-change="handleSizeChange"
      @screen-reset="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @screen-submit="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
    >
      <template #table-header="{}">
        <div style="width: 100%">
          <el-row style="padding: 0 0 10px 80px">
            <el-col :span="3" style="width: 748px">
              <div class="my-breadcrumb clear">
                <div
                  class="my-breadcrumb-item"
                  v-for="(item, index) in titleList"
                  :key="item + index"
                  @click="changeBreadcrumb(index)"
                >
                  <span class="label">{{ item.titleName }}</span
                  ><span class="separator" v-if="index + 1 !== titleList.length">/</span>
                </div>
              </div>
            </el-col>

            <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
              <el-button type="primary" :size="searchSize" @click="searchList">
                刷新
              </el-button>
            </el-col>
            <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
              <el-button type="warning" :size="searchSize" @click="restSearch">
                重置
              </el-button>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="4" style="width: 160px">
              <el-select
                v-model="parmValue.status"
                filterable
                clearable
                :size="searchSize"
                placeholder="状态"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in statusList"
                  :key="'status' + item.code"
                  :label="item.name"
                  :value="item.code"
                />
              </el-select>
            </el-col>
            <el-col :span="4" style="width: 380px; padding: 0 0 0 10px">
              <el-input
                :size="searchSize"
                v-model="parmValue.cat_name"
                :maxlength="40"
                clearable
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                @clear="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                placeholder="名称"
              />
            </el-col>
            <el-col
              :span="3"
              class="fr"
              style="width: 66px; padding: 0 0 0 10px"
              v-if="powers.some((i) => i == '002')"
            >
              <el-button
                :size="searchSize"
                type="success"
                style="float: right"
                @click="openModal({}, '002')"
              >
                添加
              </el-button>
            </el-col>
          </el-row>
        </div></template
      >
      <template #status="{ scope }">
        <el-tag
          :size="tablebtnSize"
          :type="scope.row.status == '0' ? 'warning' : ''"
          v-text="
            (statusList.find((item) => Number(item.code) == Number(scope.row.status)) || {}).name ||
            '--'
          "
        ></el-tag>
      </template>

      <template #operation="{ scope }">
        <el-tooltip
          effect="dark"
          content="详情"
          placement="top"
        >
          <i class="el-icon-view tb-icon" @click="openModal(scope.row, '007')" />
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((i) => i == '005')"
          effect="dark"
          content="修改"
          placement="top"
        >
          <i class="el-icon-edit tb-icon" @click="openModal(scope.row, '005')" />
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((i) => i == '004') && scope.row.status + '' === '1'"
          effect="dark"
          content="禁用"
          placement="top"
        >
          <i
            class="el-icon-video-pause tb-icon"
            @click="changeStatus(scope.row.id, scope.row.status)"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((i) => i == '003') && scope.row.status + '' === '0'"
          effect="dark"
          content="启用"
          placement="top"
        >
          <i
            class="el-icon-video-play tb-icon"
            @click="changeStatus(scope.row.id, scope.row.status)"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((i) => i == '006')"
          effect="dark"
          content="删除"
          placement="top"
        >
          <i class="el-icon-delete tb-icon" @click="deleteItem(scope.row.id)"></i>
        </el-tooltip>
        <!-- <el-tooltip
          v-if="powers.some((i) => i == '060')"
          effect="dark"
          content="设置毛利率"
          placement="top"
        >
          <i class="el-icon-s-check tb-icon" @click="setRate(scope.row)"></i>
        </el-tooltip> -->
        <el-tooltip
          v-if="parseInt(scope.row.level) < 3"
          effect="dark"
          content="查看下一级"
          placement="top"
        >
          <i class="el-icon-arrow-right tb-icon" @click="openChildren(scope.row)"></i>
        </el-tooltip>
      </template>
    </ex-table>

    <!-- 弹窗 新增/修改 -->
    <add-edit
      :id="modelId"
      :show-model="showModel"
      :sitem="sitem"
      :titleList="titleList"
      @refresh="searchList"
      @cancel="showModel = false"
    />
    
  </div>
</template>
<script>
import addEdit from "./addEdit";
import asyncRequest from "@/apis/service/serviceParam/sort";
import { statusList } from "@/assets/js/statusList";
import mixinPage from "@/mixins/elPaginationHandle";
import { mapGetters } from "vuex";
import resToken from "@/mixins/resToken";
export default {
  name: "sort",
  mixins: [mixinPage, resToken],
  components: {
    addEdit,
  },
  computed: {
    //组件SIZE设置
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran = this.$store.getters.btnList.find((i) => i.menu_route == "sort") || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      statusList,
      loading: true,
      showModel: false,
      modelId: "000",
      sitem: {},
      showRateModel: false,
      modelRateId: "000",
      sitemRate: {},
      titleList: [],
      parmValue: {
        page: 1, // 页码
        size: 15, // 每页显示条数
        // company_name: "", //创建人部门
        status: "",
        cat_name: "",
        pid: "0",
      },
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: [
        {
          prop: "id",
          label: "ID",
          "width": "80px",
          align:'center'
        },
        {
          prop: "cat_name",
          label: "名称",
          minWidth: "130px",
        },
        {
          prop: "status",
          label: "状态",
          _slot_: "status",
          width: "70px",
        },
        {
          prop: "level",
          label: "等级",
          width: "70px",
        },
        {
          prop: "creater",
          label: "创建人",
          minWidth: "70px",
        },
        {
          prop: "addtime",
          label: "创建时间",
          width: "145px",
        },
        {
          prop: "",
          label: "操作",
          fixed: "right",
          width: "180px",
          _noset_: true,
          _slot_: "operation",
        },
      ],
    };
  },
  mounted() {
    this.initTitleList();
    this.parmValue.pid = "0";
    this.searchList();
  },
  methods: {
    restSearch() {
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.parmValue = {
        page: 1, // 页码
        size: 15, // 每页显示条数
        status: "",
        company_name: "", //创建人部门
        pid: "0",
        cat_name: "",
      };
      this.initTitleList();
      this.searchList();
    },
    initTitleList() {
      this.titleList = [];
      let model = { id: "0", titleName: "全部一级服务分类" };
      this.titleList.push(model);
    },
    //查看下一级
    async openChildren(item) {
      this.parmValue.pid = item.id;
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
      let model = {
        id: item.id,
        titleName: item.cat_name,
      };
      this.titleList.push(model);
    },
    //设置毛利率
    setRate(row) {
      this.modelRateId = row.id;
      this.sitemRate = row;
      this.showRateModel = true;
    },
    // 新建/编辑/详情
    openModal(row, type) {
      const { status } = row;
      if (type === "005" && status + "" === "1") {
        this.$message.warning("禁用后，才可以修改！");
        return;
      }
      this.sitem = row;

      this.modelId = type;

      this.showModel = true;
    },
    async changeBreadcrumb(index) {
      if (index + 1 === this.titleList.length) {
        return;
      } else {
        this.parmValue.pid = this.titleList[index].id;
        this.titleList = this.titleList.slice(0, index + 1);
      }
      // if (this.titleList.length === 1) {
      //   this.titleList = [];
      // }
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
    /**
     * 启用/禁用
     * @param {String} id id
     * @param {String} status 0-禁用 1-启用
     */
    async changeStatus(id, status) {
      await this.$confirm(`确定要改为${status + "" === "1" ? "禁用" : "启用"}？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status + "" === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 1) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else {
            this.loading = false;
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async deleteItem(id) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
          };
          const res = await asyncRequest.delete(model);
          if (res && res.code === 1) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 刷新表格
    async searchList() {
      this.loading = true;
      const res = await asyncRequest.list(this.parmValue);
      if (res && res.code === 1 && res.data) {
        this.tableData = res.data.list;
        this.tableData.forEach((e) => {
          if (e.im && e.im.length > 0) {
            e.specs = "";
            e.im.forEach((a, i) => {
              e.specs += i === 0 ? a.spec_name : `,${a.spec_name}`;
            });
          } else {
            e.specs = "";
          }
        });
        this.pageInfo.total = Number(res.data.count);
      }  else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },
  },
};
</script>

<style lang="scss" scoped>
.sort {
  .my-breadcrumb {
    .my-breadcrumb-item {
      float: left;
      span {
        height: 32px;
        line-height: 32px;
      }
      .label {
        padding: 0 5px 0 0;
        color: 010101;
      }
      .separator {
        color: #787878;
        font-size: 13px;
        padding: 0 5px 0 0;
      }
      &:last-child {
        .label {
          color: #787878;
        }
      }
      &:hover {
        cursor: pointer;
      }
      &:last-child {
        cursor: default;
      }
      &:only-child {
        cursor: pointer;
      }
      // &.chover {
      //   cursor: pointer;
      // }
    }
  }
}
</style>
